-
Notifications
You must be signed in to change notification settings - Fork 2.4k
Create 1268-search-suggestions-system.js #2624
New issue
Have a question about this project? Sign up for a free GitHub account to open an issue and contact its maintainers and the community.
By clicking “Sign up for GitHub”, you agree to our terms of service and privacy statement. We’ll occasionally send you account related emails.
Already on GitHub? Sign in to your account
Merged
Merged
Changes from 1 commit
Commits
Show all changes
2 commits
Select commit
Hold shift + click to select a range
File filter
Filter by extension
Conversations
Failed to load comments.
Loading
Jump to
Jump to file
Failed to load files.
Loading
Diff view
Diff view
There are no files selected for viewing
This file contains hidden or bidirectional Unicode text that may be interpreted or compiled differently than what appears below. To review, open the file in an editor that reveals hidden Unicode characters.
Learn more about bidirectional Unicode characters
Original file line number | Diff line number | Diff line change |
---|---|---|
@@ -0,0 +1,46 @@ | ||
/** | ||
* Binary Search | ||
* | ||
* Time O(n*log(n) + m*n) | Space O(m) | ||
* https://leetcode.com/problems/search-suggestions-system/description/ | ||
* @param {string[]} products | ||
* @param {string} searchWord | ||
* @return {string[][]} | ||
*/ | ||
var suggestedProducts = function(products, searchWord) { | ||
|
||
products.sort((product1, product2) => { | ||
if(product1 < product2) { | ||
return -1; | ||
} | ||
if(product2 < product1) { | ||
return 1; | ||
} | ||
if(product1 === product2) { | ||
return 0; | ||
} | ||
}); | ||
|
||
const result = []; | ||
let left = 0; | ||
let right = products.length - 1; | ||
for(let i = 0; i < searchWord.length; i++) { | ||
let char = searchWord[i]; | ||
|
||
while(left <= right && (products[left].length - 1 < i || products[left][i] !== char)) { | ||
left++; | ||
} | ||
while(left <= right && (products[right].length - 1 < i || products[right][i] !== char)) { | ||
right--; | ||
} | ||
|
||
const subResult = []; | ||
const len = Math.min(right - left + 1, 3); | ||
for(let j = 0; j < len; j++) { | ||
subResult.push(products[left+j]); | ||
} | ||
result.push(subResult); | ||
} | ||
|
||
return result; | ||
}; |
Add this suggestion to a batch that can be applied as a single commit.
This suggestion is invalid because no changes were made to the code.
Suggestions cannot be applied while the pull request is closed.
Suggestions cannot be applied while viewing a subset of changes.
Only one suggestion per line can be applied in a batch.
Add this suggestion to a batch that can be applied as a single commit.
Applying suggestions on deleted lines is not supported.
You must change the existing code in this line in order to create a valid suggestion.
Outdated suggestions cannot be applied.
This suggestion has been applied or marked resolved.
Suggestions cannot be applied from pending reviews.
Suggestions cannot be applied on multi-line comments.
Suggestions cannot be applied while the pull request is queued to merge.
Suggestion cannot be applied right now. Please check back later.
There was a problem hiding this comment.
Choose a reason for hiding this comment
The reason will be displayed to describe this comment to others. Learn more.
Suggestion: Break down function to match O() complexity
There was a problem hiding this comment.
Choose a reason for hiding this comment
The reason will be displayed to describe this comment to others. Learn more.
Suggestion: Look at Trie
There was a problem hiding this comment.
Choose a reason for hiding this comment
The reason will be displayed to describe this comment to others. Learn more.
Don't you think it's too much? I mean, I might be intimidating for some people. NeetCode solved it with binary-search that's how I solved it too. It was more concise that way. But, if you want, I can add this solution in addition to the binary-search one.
There was a problem hiding this comment.
Choose a reason for hiding this comment
The reason will be displayed to describe this comment to others. Learn more.
Trie is typically a better solution since for searching, suggestions, and prefix against words.
Also the complexity is better.
There was a problem hiding this comment.
Choose a reason for hiding this comment
The reason will be displayed to describe this comment to others. Learn more.
Ok, I'll implement that.
There was a problem hiding this comment.
Choose a reason for hiding this comment
The reason will be displayed to describe this comment to others. Learn more.
@aakhtar3, I added the trie solution. But I kept the binary-search solution for reference.